DEBUG = 0

import pygtk
pygtk.require('1.2')

import _gtk, os
from string import *
from popen2 import *
from gtk import *
from Gui import *

from string import split														# String Functions
from Constants import TRUE, FALSE												# Boolean Values
from Constants import PI_NAME, PI_LOCALE_NAME, PI_VERSION, PI_ABOUT				# Program Information
from Constants import PI_COMMANDS_DIR, PI_LOCALE_DIR, PI_ICONS_DIR				# Program Directories
from Constants import ST_LOCAL_IS_NEWER, ST_REMOTE_IS_NEWER, ST_EITHER_IS_NEWER	# Synchronization types
from Constants import CT_RSH, CT_SSH, CT_FTP									# Protocols
from Constants import ST_STRINGS, CT_STRINGS									# String Representations
from Constants import URL_MANDRAKE_EXPERT, URL_MANDRAKE_QA	# URLs
from Constants import *															# Finally import everything (Menus)
from Transfer import FTPInfo, FTPTransfer, Transfer, TransferIdentity			# Data Transfer
from Wizard import Wizard														# Website Synchronization Wizard

# ------------------------------------------------------------------------------
# Localization

import gettext
gettext.bindtextdomain(PI_LOCALE_NAME, PI_LOCALE_DIR)
gettext.textdomain(PI_LOCALE_NAME)
_ = gettext.gettext

# ------------------------------------------------------------------------------
# Backwards compatibility
# (used only when reading an old preferences file)

NONE_IS_NEWER	= ST_EITHER_IS_NEWER
LOCAL_IS_NEWER	= ST_LOCAL_IS_NEWER
REMOTE_IS_NEWER	= ST_REMOTE_IS_NEWER

PROTOCOL_SSH	= CT_SSH
PROTOCOL_RSH	= CT_RSH
PROTOCOL_FTP	= CT_FTP

# ------------------------------------------------------------------------------
# Program dependencies

def check_program(progname):
	exists = FALSE
	if os.environ.has_key("PATH"):
		for dir in split(os.environ["PATH"], ":"):
			exename = os.path.join(dir, progname)
			if os.access(exename, os.X_OK):
				exists = TRUE
	return exists

have_rsync		= check_program("rsync")
have_ssh		= check_program("ssh")
have_rsh		= check_program("rsh")

# Some static configuration
# Programs (Specified as (command, (arg1, arg2, ...)))
# Program to launch to show some help
if os.environ.has_key("HELP_BROWSER"):
	command_help = ("/bin/sh", ("-c", os.environ["HELP_BROWSER"] + " " + "file:///usr/share/doc/draksync/help.html",))
else:
	command_help = (None, ())

# This is a function that just starts another program, without caring
# anything about it after the spawn...
def spawn(command, args):
	if command:
		pid = os.fork()
		if pid == 0:
			os.execvp(command, (command, ) + args)
		else:
			return pid

# General help viewer. The args are a path, e.g. show_help("foo",
# "bar", "gazonk").
def show_help(*args):
	apply(spawn, command_help)

def save(gui):
	fd = open(save_path, "w")
	fd.write(repr(gui) + "\n")
	fd.close()
	os.chmod(save_path, 0600)

def load():
	# Try to load config-file
	if os.path.exists(save_path):
		execfile(save_path)

save_path = os.path.expanduser("~/.draksync")

# ------------------------------------------------------------------------------
# Sensitivity handling

sensitive_list_sync_all					= []	# group of widgets for synchronizing everything
sensitive_list_sync_group				= []	# group of widgets for group synchronization
sensitive_list_sync_connection			= []	# group of widgets for connection synchronization
sensitive_list_group_if_active			= []	# group of widgets if a group is active
sensitive_list_group_if_inactive		= []	# group of widgets if no group is active
sensitive_list_connection_if_active		= []	# group of widgets if a connection is selected
sensitive_list_connection_if_inactive	= []	# group of widgets if no connection is selected

def strip_underscore(in_string):
	out_string = ""
	for sub_string in split(in_string, "_"):
		out_string += sub_string
	return out_string

def set_sensitive(items, active):
	for item in items:
		item.set_sensitive(active)

def update_sensitive_lists(profiles):
	profile = profiles.current()
	if not profile:
		# No active profile, it's only possible to create a new group
		set_sensitive(sensitive_list_sync_all, FALSE)
		set_sensitive(sensitive_list_group_if_inactive, TRUE)
		set_sensitive(sensitive_list_group_if_active, FALSE)
		set_sensitive(sensitive_list_connection_if_inactive, FALSE)
		set_sensitive(sensitive_list_connection_if_active, FALSE)
	else:
		# Defaults to "inactive mode" except for group
		set_sensitive(sensitive_list_group_if_inactive, TRUE)
		set_sensitive(sensitive_list_connection_if_inactive, TRUE)
		set_sensitive(sensitive_list_group_if_active, TRUE)
		set_sensitive(sensitive_list_connection_if_active, FALSE)

		# Enable all synchronization if there is actually
		# something to synchronize in one of the groups
		exists_connection = FALSE
		for profile in profiles.profiles:
			exists_connection = exists_connection or (len(profile.items) != 0)
		set_sensitive(sensitive_list_sync_all, exists_connection)

		# Enable group synchronization if there is actually
		# something to synchronize in the active group
		profile = profiles.current()
		exists_connection = len(profile.items) != 0
		set_sensitive(sensitive_list_sync_group, exists_connection)

		item = profile.current()
		if not item:
			# No active item, offers the possibility only for creating a new connection
			set_sensitive(sensitive_list_connection_if_active, FALSE)
		else:
			set_sensitive(sensitive_list_connection_if_inactive, TRUE)
			set_sensitive(sensitive_list_connection_if_active, TRUE)
	

class Identity:
	def __got_input__(self, *args):
		input = self.adder.read(1)
		if input == "":
			self.cancel()
		elif input == "\n":
			# These are the input categories:
			#ERROR[: .*]
			if find(self.input, "ERROR") == 0:
				if self.input == "ERROR: PERMISSION DENIED":
					if not self.adder.closed:
						_gtk.gtk_input_remove(self.input_tag)
						self.adder.close()
					GuiPopupPasswordInput(PI_NAME + " - " + _("Permission denied"),
										  _("Permission denied. Please reenter the passphrase for your ssh identity:"),
										  "", (self.ui_password_cancel, None),
										  ((_("OK"), self.ui_password_ok, None, GRAB_DEFAULT), (_("Cancel"), self.ui_password_cancel, None))).show()
				elif self.input == "ERROR: NO SSH-AGENT":
					GuiPopupQuestion(PI_NAME + " - " + _("Installation problem"),
									 _("You seem not to have ssh-agent installed.") + " " +
									 _("Please verify that you have ssh installed correctly and your PATH set up to include the installation directory of ssh."),
									 (None, None), ((_("OK"), None, None, GRAB_DEFAULT),)).show()
					self.cancel()
				else:
					GuiPopupQuestion(PI_NAME + " - " + _("Unknown error"),
									 _("An unknown error '%s' has occurred.") % self.input,
									 (None, None), ((_("OK"), None, None, GRAB_DEFAULT),)).show()
					self.cancel()
			elif self.input == "DONE": 
				self.cont()
			self.input = ""
		else:
			self.input = self.input + input
	def __init__(self):
		self.continues = []
	def add(self, cont = (None, None), cancel = (None, None)):
		first = self.continues == []
		self.continues.append((cont, cancel))
		if first:
			GuiPopupPasswordInput(PI_NAME + " - " + _("Passphrase required for ssh identity"),
								  _("Your ssh identity requires a passphrase.") + "\n" +
								  _("Please enter your passphrase:"),
								  "", (self.ui_password_cancel, None),
								  ((_("OK"), self.ui_password_ok, None, GRAB_DEFAULT), (_("Cancel"), self.ui_password_cancel, None))).show()
	def ui_password_ok(self, passwd):
		self.input = ""
		self.adder, self.adderin = popen2(PI_COMMANDS_DIR + "/unsetlang " + PI_COMMANDS_DIR + "/add_identity.exp 2>&1", 0)
		self.adderin.write("PASSWORD: " + passwd + "\n")
		self.input_tag = _gtk.gtk_input_add(self.adder.fileno(), INPUT_READ, self.__got_input__);
	def ui_password_cancel(self, text):
		self.cont_cancel()
	def cont(self):
		if not self.adder.closed:
			_gtk.gtk_input_remove(self.input_tag)
			self.adder.close()
		for cont in self.continues:
			if cont[0][1]:
				apply(cont[0][0], cont[0][1])
			else:
				apply(cont[0][0], ())
		self.continues = []
	def cont_cancel(self):
		for cont in self.continues:
			if cont[1][1]:
				apply(cont[1][0], cont[1][1])
			else:
				apply(cont[1][0], ())
		self.continues = []
	def cancel(self):
		if not self.adder.closed:
			_gtk.gtk_input_remove(self.input_tag)
			self.adder.close()
		self.cont_cancel()
identity = Identity()

class ItemDescription(GtkListItem):
	icon_some_is_newer = None
	icon_none_is_newer = None
	def local_desc(self):
		return self.local
	def remote_desc(self):
		if self.protocol == CT_FTP:
			proto = "ftp"
		elif self.protocol == CT_RSH:
			proto = "rsh"
		else:
			proto = "ssh"
		return proto + "://" + self.user + "@" + self.host + ":" + self.remote
	def pretext(self):
		if self.newer == ST_REMOTE_IS_NEWER:
			return self.remote_desc()   
		else:
			return self.local_desc()
	def posttext(self):
		if self.newer == ST_REMOTE_IS_NEWER:
			return self.local_desc()
		else:
			return self.remote_desc()   
	def __init__(self, local, user, host, remote, newer, protocol):
		ItemDescription.__bases__[0].__init__(self)
		_gtk.gtk_object_set_data(self._o, "userclass", self)
		self.local = local
		self.user = user
		self.host = host
		self.remote = remote
		self.newer = newer
		self.protocol = protocol
		self.set_border_width(BORDER_WIDTH)
		if not ItemDescription.icon_some_is_newer:
			ItemDescription.icon_some_is_newer = create_pixmap_from_xpm(self, self.get_style().bg[STATE_NORMAL], PI_ICONS_DIR + "/some_is_newer.xpm")
		if not ItemDescription.icon_none_is_newer:
			ItemDescription.icon_none_is_newer = create_pixmap_from_xpm(self, self.get_style().bg[STATE_NORMAL], PI_ICONS_DIR + "/none_is_newer.xpm")
		self.box = GtkHBox()
		self.prelabel = GtkLabel(self.pretext())
		self.box.pack_start(self.prelabel, FALSE, FALSE, 0)
		if self.newer == ST_EITHER_IS_NEWER:
			self.direction = GtkPixmap(self.icon_none_is_newer[0], self.icon_none_is_newer[1])
		else:
			self.direction = GtkPixmap(self.icon_some_is_newer[0], self.icon_some_is_newer[1])
		self.box.pack_start(self.direction, FALSE, FALSE, 0)
		self.postlabel = GtkLabel(self.posttext())
		self.box.pack_start(self.postlabel, FALSE, FALSE, 0)
		self.add(self.box)

	def show(self):
		self.prelabel.show()
		self.direction.show()
		self.postlabel.show()
		self.box.show()
		ItemDescription.__bases__[0].show(self)
	def set(self, local, user, host, remote, newer, protocol):
		self.local = local
		self.user = user
		self.host = host
		self.remote = remote
		self.newer = newer
		self.protocol = protocol
		self.prelabel.set_text(self.pretext())
		self.postlabel.set_text(self.posttext())
		if self.newer == ST_EITHER_IS_NEWER:
			self.direction.set(self.icon_none_is_newer[0], self.icon_none_is_newer[1])
		else:
			self.direction.set(self.icon_some_is_newer[0], self.icon_some_is_newer[1])

class Item(GtkWindow):
	def __init__(self, local="", user="", password=None, host="", remote="", newer=ST_EITHER_IS_NEWER, protocol=CT_SSH, delete_files=TRUE): 
		Item.__bases__[0].__init__(self)
		_gtk.gtk_object_set_data(self._o, "userclass", self)
		self.connect("delete_event", self.ui_close)
		self.set_title(PI_NAME + " - " + _("Edit connection"))
		self.set_border_width(BORDER_WIDTH)
		self.description = ItemDescription(local, user, host, remote, newer, protocol)
		_gtk.gtk_object_set_data(self.description._o, "item", self)
		self.box = GtkVBox(FALSE, BORDER_WIDTH)
		self.mainbox = GtkHBox(FALSE, BORDER_WIDTH)
		self.leftbox = GtkVBox(FALSE, BORDER_WIDTH)

		###### Local #####
		self.localframe = GtkFrame(_("Local"))
		self.localbox = GtkHBox(FALSE, BORDER_WIDTH)
		self.localbox.set_border_width(BORDER_WIDTH)
		self.localdirlabel = GtkLabel(_("Directory:"))
		self.localbox.pack_start(self.localdirlabel, FALSE, FALSE, 0)
		self.localdir = GtkEntry()
		self.localdir.set_text(local)
		self.localbox.pack_start(self.localdir, TRUE, TRUE, 0)
		self.localdirselector = GtkButton(_("..."))
		self.localdirselector.connect("clicked", self.ui_selectlocaldir)
		self.localbox.pack_start(self.localdirselector, FALSE, FALSE, 0)
		self.localframe.add(self.localbox)
		self.leftbox.pack_start(self.localframe, FALSE, FALSE, 0)
		##### Remote #####
		self.remoteframe = GtkFrame(_("Remote"))
		self.remotebox = GtkVBox(FALSE, BORDER_WIDTH)
		self.remotebox.set_border_width(BORDER_WIDTH)
		self.remotehostbox = GtkHBox(FALSE, BORDER_WIDTH)
		self.remotehostlabel = GtkLabel(_("Host:"))
		self.remotehostbox.pack_start(self.remotehostlabel, FALSE, FALSE, 0)
		self.remotehost = GtkEntry()
		self.remotehost.set_text(host)
		self.remotehostbox.pack_start(self.remotehost, TRUE, TRUE, 0)
		self.remotebox.pack_start(self.remotehostbox, FALSE, FALSE, 0)
		self.remoteuserbox = GtkHBox(FALSE, BORDER_WIDTH)
		self.remoteuserlabel = GtkLabel(_("User:"))
		self.remoteuserbox.pack_start(self.remoteuserlabel, FALSE, FALSE, 0)
		self.remoteuser = GtkEntry()
		self.remoteuser.set_text(user)
		self.remoteuserbox.pack_start(self.remoteuser, TRUE, TRUE, 0)
		self.remotebox.pack_start(self.remoteuserbox, FALSE, FALSE, 0)
		self.remotedirbox = GtkHBox(FALSE, BORDER_WIDTH)
		self.remotedirlabel = GtkLabel(_("Directory:"))
		self.remotedirbox.pack_start(self.remotedirlabel, FALSE, FALSE, 0)
		self.remotedir = GtkEntry()
		self.remotedir.set_text(remote)
		self.remotedirbox.pack_start(self.remotedir, TRUE, TRUE, 0)
		self.remotebox.pack_start(self.remotedirbox, FALSE, FALSE, 0)
		self.remoteupload = GtkButton(_("Upload public ssh key to remote host"))
		self.remoteupload.connect("clicked", self.ui_upload)
		self.remotebox.pack_start(self.remoteupload, FALSE, FALSE, 0)
		self.remoteframe.add(self.remotebox)
		self.leftbox.pack_start(self.remoteframe, TRUE, TRUE, 0)
		self.mainbox.pack_start(self.leftbox, TRUE, TRUE, 0)
		##### Sync ######
		self.syncframe = GtkFrame(_("Synchronization"))
		self.syncbox = GtkVBox(FALSE, BORDER_WIDTH)
		##### Direction #####
		self.syncdirectionframe = GtkFrame(_("Direction:"))
		self.syncdirectionframe.set_shadow_type(SHADOW_NONE)
		self.syncdirectionbox = GtkVBox()
		self.syncdirection_none_is_newer = GtkRadioButton(label=_("Copy most recent files"))
		if newer == ST_EITHER_IS_NEWER:
			self.syncdirection_none_is_newer.set_active(TRUE)
		self.syncdirectionbox.pack_start(self.syncdirection_none_is_newer, FALSE, FALSE, 0)
		self.syncdirection_local_is_newer = GtkRadioButton(self.syncdirection_none_is_newer, _("Copy local files to remote"))
		if newer == ST_LOCAL_IS_NEWER:
			self.syncdirection_local_is_newer.set_active(TRUE)
		self.syncdirectionbox.pack_start(self.syncdirection_local_is_newer, FALSE, FALSE, 0)
		self.syncdirection_remote_is_newer = GtkRadioButton(self.syncdirection_local_is_newer, _("Copy remote files to local"))
		if newer == ST_REMOTE_IS_NEWER:
			self.syncdirection_remote_is_newer.set_active(TRUE)
		self.syncdirectionbox.pack_start(self.syncdirection_remote_is_newer, FALSE, FALSE, 0)
		self.syncdirectionframe.add(self.syncdirectionbox)
		self.syncbox.pack_start(self.syncdirectionframe, FALSE, FALSE, 0)
		##### Protocol #####
		self.syncprotocolframe = GtkFrame(_("Protocol:"))
		self.syncprotocolframe.set_shadow_type(SHADOW_NONE)
		self.syncprotocolbox = GtkVBox()
		self.syncprotocolbox_ssh = GtkRadioButton(label=_("Rsync over SSH (Secure SHell) - secure"))
		if protocol == CT_SSH:
			self.syncprotocolbox_ssh.set_active(TRUE)
		if not have_rsync or not have_ssh:
			self.syncprotocolbox_ssh.set_sensitive(FALSE)
		self.syncprotocolbox_ssh.connect("toggled", self.ui_protocol_ssh_toggle)
		self.ui_protocol_ssh_toggle(self.syncprotocolbox_ssh)
		self.syncprotocolbox.pack_start(self.syncprotocolbox_ssh, FALSE, FALSE, 0)
		self.syncprotocolbox_rsh = GtkRadioButton(self.syncprotocolbox_ssh, _("Rsync over RSH (Remote SHell) - insecure"))
		if protocol == CT_RSH:
			self.syncprotocolbox_rsh.set_active(TRUE)
		if not have_rsync or not have_rsh:
			self.syncprotocolbox_rsh.set_sensitive(FALSE)
		self.syncprotocolbox.pack_start(self.syncprotocolbox_rsh, FALSE, FALSE, 0)
		self.syncprotocolbox_ftp = GtkRadioButton(self.syncprotocolbox_rsh, _("FTP (File Transfer Protocol) - insecure"))
		self.ftpinfo = FTPInfo(host, user, password, local, remote)
		if protocol == CT_FTP:
			self.syncprotocolbox_ftp.set_active(TRUE)
		self.syncprotocolbox.pack_start(self.syncprotocolbox_ftp, FALSE, FALSE, 0)
		self.syncprotocolframe.add(self.syncprotocolbox)
		self.syncbox.pack_start(self.syncprotocolframe, FALSE, FALSE, 0)
		##### Options ######
		self.syncoptionsframe = GtkFrame(_("Options:"))
		self.syncoptionsframe.set_shadow_type(SHADOW_NONE)
		self.syncoptionsbox = GtkVBox()
		self.syncoptions_delete = GtkCheckButton(_("Delete files"))
		self.syncoptions_delete.set_active(delete_files)
		self.syncdirection_none_is_newer.connect("toggled", self.ui_direction_toggle)
		self.ui_direction_toggle(self.syncdirection_none_is_newer)
		self.syncoptionsbox.pack_start(self.syncoptions_delete, FALSE, FALSE, 0)
		self.syncoptions_remember_password = GtkCheckButton(_("Remember password"))
		if password != None:
			self.syncoptions_remember_password.set_active(TRUE)
		if protocol != CT_FTP:
			self.syncoptions_remember_password.set_sensitive(FALSE)
		self.syncprotocolbox_ftp.connect("toggled", self.ui_protocol_ftp_toggle)
		self.syncoptionsbox.pack_start(self.syncoptions_remember_password, FALSE, FALSE, 0)
		self.syncoptionsframe.add(self.syncoptionsbox)
		self.syncbox.pack_start(self.syncoptionsframe, FALSE, FALSE, 0)
		self.syncframe.add(self.syncbox)
		self.mainbox.pack_start(self.syncframe, FALSE, FALSE, 0)
		self.box.pack_start(self.mainbox, TRUE, TRUE, 0)
		##### Buttonbox/Actions ######
		self.buttonbox = GtkHBox(FALSE, BORDER_WIDTH)
		self.syncbtn = GtkButton(_("Synchronize"))
		self.syncbtn.connect("clicked", self.ui_sync)
		self.buttonbox.pack_start(self.syncbtn, FALSE, FALSE, 0)
		self.close = GtkButton(_("Close"))
		self.close.connect("clicked", self.ui_close)
		self.buttonbox.pack_start(self.close, FALSE, FALSE, 0)
		self.box.pack_start(self.buttonbox, FALSE, FALSE, 0)
		self.add(self.box)
	def newer(self):
		if self.syncdirection_local_is_newer.get_active():
			return ST_LOCAL_IS_NEWER
		elif self.syncdirection_remote_is_newer.get_active():
			return ST_REMOTE_IS_NEWER
		elif self.syncdirection_none_is_newer.get_active():
			return ST_EITHER_IS_NEWER
	def protocol(self):
		if self.syncprotocolbox_rsh.get_active():
			return CT_RSH
		elif self.syncprotocolbox_ftp.get_active():
			return CT_FTP
		elif self.syncprotocolbox_ssh.get_active():
			return CT_SSH
	def show(self):
		self.localdirlabel.show()
		self.localdir.show()
		self.localdir.grab_focus()
		self.localdirselector.show()
		self.localbox.show()
		self.localframe.show()
		self.remoteuserlabel.show()
		self.remoteuser.show()
		self.remoteuserbox.show()
		self.remotehostlabel.show()
		self.remotehost.show()
		self.remotehostbox.show()
		self.remotedirlabel.show()
		self.remotedir.show()
		self.remotedirbox.show()
		self.remoteupload.show()
		self.remotebox.show()
		self.remoteframe.show()
		self.leftbox.show()
		self.syncdirection_none_is_newer.show()
		self.syncdirection_local_is_newer.show()
		self.syncdirection_remote_is_newer.show()
		self.syncdirectionbox.show()
		self.syncdirectionframe.show()
		self.syncprotocolbox_ssh.show()
		self.syncprotocolbox_rsh.show()
		self.syncprotocolbox_ftp.show()
		self.syncprotocolbox.show()
		self.syncprotocolframe.show()
		self.syncoptions_delete.show()
		self.syncoptions_remember_password.show()
		self.syncoptionsbox.show()
		self.syncoptionsframe.show()
		self.syncbox.show()
		self.syncframe.show()
		self.mainbox.show()
		self.close.show()
		self.syncbtn.show()
		self.buttonbox.show()
		self.box.show()
		Item.__bases__[0].show(self)
	def __repr__(self):
		if self.syncoptions_remember_password.get_active():
			password_str = repr(self.ftpinfo.password)
		else:
			password_str = "None"
		return	"Item(local = " + repr(self.localdir.get_text()) +						\
				", user = " + repr(self.remoteuser.get_text()) +						\
				", host = " + repr(self.remotehost.get_text()) +						\
				", password = " + password_str +										\
				", remote = " + repr(self.remotedir.get_text()) +						\
				", newer = " + ST_STRINGS[self.newer()] +								\
				", protocol = " + CT_STRINGS[self.protocol()] +							\
				", delete_files = " + repr(self.syncoptions_delete.get_active()) +		\
				")"
	def sync(self, *args):
		if self.protocol() == CT_FTP:
			# update ftpinfo
			self.ftpinfo.hostname = self.remotehost.get_text()
			self.ftpinfo.username = self.remoteuser.get_text()
			self.ftpinfo.local_dir = self.localdir.get_text()
			self.ftpinfo.remote_dir = self.remotedir.get_text()
			if not self.syncoptions_remember_password.get_active():
				self.ftpinfo.password = None
			FTPTransfer(self.newer(), self.syncoptions_delete.get_active(),	self.ftpinfo)
		else:
			# Check that we can actually launch the synchronization (are the requested programs available ?)
			missing_program = None
			if not have_rsync:
				missing_program = "rsync"
			elif (self.protocol() == CT_SSH) and not have_ssh:
				missing_program = "ssh"
			elif (self.protocol() == CT_RSH) and not have_rsh:
				missing_program = "rsh"
			if missing_program:
				GuiPopupQuestion(PI_NAME + " - " + _("External program not found"),
								 _("Could not find the required program '%s' for synchronization.\n"
								   "Please make sure it is correctly installed and that your PATH\n"
								   "contains the installation directory for it.") % missing_program,
								 (None, None), ((_("OK"), None, None, GRAB_DEFAULT),)).show()
			else:
				Transfer(self.protocol(),
						 self.localdir.get_text(),
						 self.remoteuser.get_text(),
						 self.remotehost.get_text(),
						 self.remotedir.get_text(),
						 self.newer(),
						 self.syncoptions_delete.get_active())
#Callbacks##Ui
	def ui_direction_toggle(self, button):
		self.syncoptions_delete.set_sensitive(not self.syncdirection_none_is_newer.get_active())
	def ui_protocol_ssh_toggle(self, button):
		self.remoteupload.set_sensitive(self.syncprotocolbox_ssh.get_active())
	def ui_protocol_ftp_toggle(self, button):
		self.syncoptions_remember_password.set_sensitive(self.syncprotocolbox_ftp.get_active())
	def ui_upload(self, *args):
		GuiPopupPasswordInput(PI_NAME + " - " + _("Passphrase required for host"),
							  _("Uploading ssh identity always requires a passphrase for the account.") + "\n" +
							  _("Please enter your passphrase for %s@%s:") % (self.remoteuser.get_text(), self.remotehost.get_text()),
							  "", (None, None), ((_("OK"), self.ui_upload_upload, None, GRAB_DEFAULT), (_("Cancel"), None, None))).show()
	def ui_upload_upload(self, passwd):
		TransferIdentity(passwd, self.remoteuser.get_text(), self.remotehost.get_text())
	def ui_close(self, *args):
		self.description.set(self.localdir.get_text(), self.remoteuser.get_text(), self.remotehost.get_text(), self.remotedir.get_text(), self.newer(), self.protocol())
		self.hide()
		return TRUE
	def ui_sync(self, *args):
		self.sync()
	def ui_selectlocaldir(self, *args):
		GuiPopupDirectorySelection(PI_NAME + " - " + _("Please select local directory"),
								   self.localdir.get_text(), ok=(self.ui_selectlocaldirselected, None)).show()
	def ui_selectlocaldirselected(self, path):
		self.localdir.set_text(path)

class Profile(GtkList):
	def __init__(self, name, *items):
		Profile.__bases__[0].__init__(self)
		_gtk.gtk_object_set_data(self._o, "userclass", self)
		self.connect("select-child", self.ui_select_child)
		self.connect("unselect-child", self.ui_unselect_child)
		self.name = name
		self.label = GtkLabel(self.name)
		self.items = []
		self.current_item = None
		for item in items:
			self.do_add(item)
		
	def set_title(self, name):
		self.label.set_text(name)
		
	def do_add(self, item):
		# internal version without updates to the sensitive lists
		self.items.append(item)
		self.append_items([item.description])

	def add(self, item):
		self.do_add(item)
		update_sensitive_lists(gui.profiles)
		
	def do_remove(self, item):
		# internal version without updates to the sensitive lists
		if item == self.current():
			activate = self.child_position(item.description)
		else:
			activate = -1
		# We have to iterate backwards, to know that the indices are still
		# valid after a removal (So that we don't exceed the limit of the
		# array)
		for index in range(len(self.items) - 1, -1, -1):
			if self.items[index] == item:
				self.items[index:index+1] = []
		self.remove_items([item.description])
		if activate != -1:
			self.select_item(activate)

	def remove(self, item):
		self.do_remove(item)
		update_sensitive_lists(gui.profiles)
		
	def current(self):
		return self.current_item
	
	def show(self):
		for item in self.items:
			item.description.show()
		self.label.show()
		Profile.__bases__[0].show(self)
		
	def __repr__(self):
		res = "Profile(" + repr(self.label.get())
		for item in self.items:
			res = res + ", " + repr(item)
		res = res + ")"
		return res
	
	def sync(self):
		for item in self.items:
			item.sync()

#Callbacks##Ui
	def ui_select_child(self, list, child):
		self.current_item = _gtk.gtk_object_get_data(child._o, "item")
		# if we could select an item, then a group is bound to exist
		set_sensitive(sensitive_list_connection_if_active, TRUE)
		set_sensitive(sensitive_list_connection_if_inactive, TRUE)
		
	def ui_unselect_child(self, list, child):
		if self.current_item == _gtk.gtk_object_get_data(child._o, "item"):
			self.current_item = None
		# if we could select an item, then a group is bound to exist
		set_sensitive(sensitive_list_connection_if_active, FALSE)
		set_sensitive(sensitive_list_connection_if_inactive, TRUE)

class Profiles(GtkNotebook):
	def __init__(self, *profiles):
		Profiles.__bases__[0].__init__(self)
		_gtk.gtk_object_set_data(self._o, "userclass", self)
		self.signal_connect_after("switch-page", self.ui_switch_page)
		self.set_scrollable(TRUE)
		self.set_tab_pos(POS_TOP)
		self.profiles = []
		for profile in profiles:
			self.do_add(profile)

		# Popup menu
		item_factory = GtkItemFactory(GtkMenu, "<main>", GtkAccelGroup())
		item_factory.create_items([
			( MNP_ALL_SYNC,				None,	self.mn_all_sync_handler,				0,		None			),
			( MNP_SEPARATOR,			None,	None,									0,		"<Separator>"	),
			( MNP_GROUP_SYNC,			None,	self.mn_group_sync_handler,				0,		None			),
			( MNP_GROUP_ADD,			None,	self.mn_group_add_handler,				0,		None			),
			( MNP_GROUP_REMOVE,			None,	self.mn_group_remove_handler,			0,		None			),
			( MNP_GROUP_RENAME,			None,	self.mn_group_rename_handler,			0,		None			),
			( MNP_SEPARATOR,			None,	None,									0,		"<Separator>"	),
			( MNP_CONNECTION_SYNC,		None,	self.mn_connection_sync_handler,		0,		None			),
			( MNP_CONNECTION_EDIT,		None,	self.mn_connection_edit_handler,		0,		None			),
			( MNP_CONNECTION_ADD,		None,	self.mn_connection_add_handler,			0,		None			),
			( MNP_CONNECTION_REMOVE,	None,	self.mn_connection_remove_handler,		0,		None			)
			])
		self.popup_menu = item_factory.get_widget("<main>")
		self.signal_connect_object("button_press_event", self.__popup_menu_handler, self.popup_menu)

		# Update sensitivity widget lists
		sensitive_list_sync_all.append(					item_factory.get_widget(strip_underscore( MNP_ALL_SYNC			)))
		sensitive_list_sync_group.append(				item_factory.get_widget(strip_underscore( MNP_GROUP_SYNC		)))
		sensitive_list_sync_connection.append(			item_factory.get_widget(strip_underscore( MNP_CONNECTION_SYNC	)))
		sensitive_list_group_if_inactive.append(		item_factory.get_widget(strip_underscore( MNP_GROUP_ADD			)))
		sensitive_list_group_if_active.extend([			item_factory.get_widget(strip_underscore( MNP_GROUP_SYNC		)),
														item_factory.get_widget(strip_underscore( MNP_GROUP_REMOVE		)),
														item_factory.get_widget(strip_underscore( MNP_GROUP_RENAME		))])
		sensitive_list_connection_if_inactive.append(	item_factory.get_widget(strip_underscore( MNP_CONNECTION_ADD	)))
		sensitive_list_connection_if_active.extend([	item_factory.get_widget(strip_underscore( MNP_CONNECTION_SYNC	)),
														item_factory.get_widget(strip_underscore( MNP_CONNECTION_EDIT	)),
														item_factory.get_widget(strip_underscore( MNP_CONNECTION_REMOVE	))])

# Callbacks: /All
	def mn_all_sync_handler(self, *args):
		if (self.get_current_page() != -1):
			self.sync()

# Callbacks: /Group
	def mn_group_sync_handler(self, *args):
		profile = self.current()
		if profile:
			profile.sync()

	def mn_group_do_add_handler(self, name):
		profile = Profile(name)
		profile.show()
		self.add(profile)
		
	def mn_group_add_handler(self, *args):
		GuiPopupInput(PI_NAME + " - " + _("New group"),
					  _("Please enter a name for the new group:"), "", (None, None),
					  ((_("OK"), self.mn_group_do_add_handler, None, GRAB_DEFAULT), (_("Cancel"), None, None))).show()

	def mn_group_do_remove_handler(self, profile, *args):
		self.remove(profile)
	
	def mn_group_remove_handler(self, *args):
		profile = self.current()
		if profile:
			GuiPopupQuestion(PI_NAME + " - " + _("Remove group"),
							 _("Remove the current group and all its connections?"), (None, None),
							 ((_("Yes"), self.mn_group_do_remove_handler, (profile,)), (_("No"), None, None, GRAB_DEFAULT))).show()

	def mn_group_do_rename_handler(self, name, profile):
		profile.set_title(name)
	
	def mn_group_rename_handler(self, *args):
		profile = self.current()
		if profile:
			GuiPopupInput(PI_NAME + " - " + _("Rename group"),
						  _("Please enter the new name for the group:"), "", (None, None),
						  ((_("OK"), self.mn_group_do_rename_handler, (profile,), GRAB_DEFAULT), (_("Cancel"), None, None))).show()

# Callbacks: /Connection
	def mn_connection_sync_handler(self, *args):
		profile = self.current()
		if profile:
			connection = profile.current()
			if connection:
				connection.sync()
	
	def mn_connection_edit_handler(self, *args):
		profile = self.current()
		if profile:
			connection = profile.current()
			if connection:
				connection.show()
	
	def mn_connection_add_handler(self, *args):
		profile = self.current()
		if profile:
			item = Item()
			item.description.show()
			item.show()
			profile.add(item)

	def mn_connection_do_remove_handler(self, profile, connection):
		profile.remove(connection)
	
	def mn_connection_remove_handler(self, *args):
		profile = self.current()
		if profile:
			connection = profile.current()
			if connection:
				GuiPopupQuestion(PI_NAME + " - " + _("Remove connection"),
								 _("Remove the current connection?"), (None, None),
								 ((_("Yes"), self.mn_connection_do_remove_handler, (profile, connection)), (_("No"), None, None, GRAB_DEFAULT))).show()

# Callbacks: popup menu
	def __popup_menu_handler(self, menu, event):
		if isinstance(menu, GtkMenu) and (event.type == BUTTON_PRESS) and (event.button == 3):
			self.popup_menu.popup(None, None, None, event.button, event.time)
			retval = TRUE
		else:
			retval = FALSE
		return retval

	def do_add(self, profile):
		# internal version without updates to the sensitive lists
		self.profiles.append(profile)
		scroller = GtkScrolledWindow()
		scroller.set_policy(POLICY_AUTOMATIC, POLICY_AUTOMATIC)
		scroller.add_with_viewport(profile)
		scroller.show()
		_gtk.gtk_object_set_data(scroller._o, "profile", profile)
		_gtk.gtk_object_set_data(profile._o, "scroller", scroller)
		self.append_page(scroller, profile.label)

	def add(self, profile):
		self.do_add(profile)
		update_sensitive_lists(self)
		
	def do_remove(self, profile):
		# internal version without updates to the sensitive lists
		pagenum = self.page_num(_gtk.gtk_object_get_data(profile._o, "scroller"))
		if pagenum != -1:
			self.remove_page(pagenum)
		for index in range(len(self.profiles) - 1, -1, -1):
			if self.profiles[index] == profile:
				self.profiles[index:index+1] = []

	def find(self, name):
		# Returns None if the profile NAME does not exist, returns the instance otherwise
		for page in range(len(self.profiles)):
			profile = _gtk.gtk_object_get_data(self.get_nth_page(page)._o, "profile")
			if profile.name == name:
				return profile
		return None

	def remove(self, profile):
		self.do_remove(profile)
		update_sensitive_lists(self)
		
	def current(self):
		page = self.get_current_page()
		if page != -1:
			return _gtk.gtk_object_get_data(self.get_nth_page(page)._o, "profile")
		else:
			return None

	def ui_switch_page(self, *args):
		update_sensitive_lists(self)
		
	def show(self):
		for profile in self.profiles:
			profile.show()
		Profiles.__bases__[0].show(self)
		
	def __repr__(self):
		res = "Profiles("
		sep = ""
		for profile in self.profiles:
			res = res + sep + repr(profile)
			sep = ", "
		res = res + ")"
		return res
	
	def sync(self):
		for profile in self.profiles:
			profile.sync()

class GuiMenubar(GtkHandleBox):

	def __init__(self, gui):
		GuiMenubar.__bases__[0].__init__(self)
		_gtk.gtk_object_set_data(self._o, "userclass", self)
		self.gui = gui
		accel_group = GtkAccelGroup()
		item_factory = GtkItemFactory(GtkMenuBar, "<main>", accel_group)
		item_factory.create_items([
			( MN_FILE,					None,			None,					0,		"<Branch>"		),
			( MN_FILE_WEBSYNC_WIZARD,	"<control>W",	self.ui_file_wizard,	0,		None			),
			( MN_FILE_SEPARATOR,		None,			None,					0,		"<Separator>"	),
			( MN_FILE_SYNC_ALL,			"<control>Y",	self.ui_file_sync,		0,		None			),
			( MN_FILE_SAVE_AND_QUIT,	"<control>S",	self.ui_file_quit,		0,		None			),
			( MN_FILE_QUIT_WO_SAVING,	"<control>Q",	self.ui_file_exit,		0,		None			),
			( MN_GROUP,					None,			None,					0,		"<Branch>"		),
			( MN_GROUP_SYNC,			None,			self.ui_group_sync,		0,		None			),
			( MN_GROUP_ADD,				None,			self.ui_group_add,		0,		None			),
			( MN_GROUP_REMOVE,			None,			self.ui_group_remove,	0,		None			),
			( MN_GROUP_RENAME,			None,			self.ui_group_rename,	0,		None			),
			( MN_CONNECTION,			None,			None,					0,		"<Branch>"		),
			( MN_CONNECTION_SYNC,		None,			self.ui_conn_sync,		0,		None			),
			( MN_CONNECTION_ADD,		None,			self.ui_conn_add,		0,		None			),
			( MN_CONNECTION_REMOVE,		None,			self.ui_conn_remove,	0,		None			),
			( MN_CONNECTION_EDIT,		None,			self.ui_conn_edit,		0,		None			),
			( MN_HELP,					None,			None,					0,		"<Branch>"		),
			( MN_HELP_MANUAL,			None,			self.ui_help_help,		0,		None			),
			( MN_HELP_SEPARATOR,		None,			None,					0,		"<Separator>"	),
			( MN_HELP_MANDRAKE_EXPERT,	None,			self.ui_help_expert,	0,		None			),
			( MN_HELP_SEPARATOR,		None,			None,					0,		"<Separator>"	),
			( MN_HELP_BUG_REPORT,		None,			self.ui_help_bugreport,	0,		None			),
			( MN_HELP_SEPARATOR,		None,			None,					0,		"<Separator>"	),
			( MN_HELP_ABOUT,			None,			self.ui_help_about,		0,		None			)
			])
		self.gui.add_accel_group(accel_group)
		self.menubar = item_factory.get_widget("<main>")
		self.add(self.menubar)

		# Update sensitivity widget lists
		sensitive_list_sync_all.append(					item_factory.get_widget(strip_underscore( MN_FILE_SYNC_ALL		)))
		sensitive_list_sync_group.append(				item_factory.get_widget(strip_underscore( MN_GROUP_SYNC			)))
		sensitive_list_sync_connection.append(			item_factory.get_widget(strip_underscore( MN_CONNECTION_SYNC	)))
		sensitive_list_group_if_inactive.append(		item_factory.get_widget(strip_underscore( MN_GROUP_ADD			)))
		sensitive_list_group_if_active.extend([			item_factory.get_widget(strip_underscore( MN_GROUP_SYNC			)),
														item_factory.get_widget(strip_underscore( MN_GROUP_REMOVE		)),
														item_factory.get_widget(strip_underscore( MN_GROUP_RENAME		))])
		sensitive_list_connection_if_inactive.append(	item_factory.get_widget(strip_underscore( MN_CONNECTION_ADD		)))
		sensitive_list_connection_if_active.extend([	item_factory.get_widget(strip_underscore( MN_CONNECTION_SYNC	)),
														item_factory.get_widget(strip_underscore( MN_CONNECTION_EDIT	)),
														item_factory.get_widget(strip_underscore( MN_CONNECTION_REMOVE	))])
	
	def show(self):
		self.menubar.show()
		GuiMenubar.__bases__[0].show(self)

# Callbacks: /File
	def ui_file_wizard(self, *args):
		ftpinfo = Wizard().run()
		if ftpinfo != None:
			add_save_ftp_profile(_("My Websites"), ftpinfo)
	def ui_file_sync(self, *args):
		self.gui.profiles.sync()
	def ui_file_quit(self, *args):
		self.gui.ui_close()
	def ui_file_exit(self, *args):
		GuiPopupQuestion(PI_NAME + " - " + _("Quit without saving"),
						 _("Quit without saving changes?"), (None, None),
						 ((_("Yes"), self.ui_file_do_exit, None), (_("No"), None, None, GRAB_DEFAULT))).show()
	def ui_file_do_exit(self):
		mainquit()

# Callbacks: /Group
	def ui_group_add(self, *args):
		GuiPopupInput(PI_NAME + " - " + _("New group"),
					  _("Please enter a name for the new group:"), "", (None, None),
					  ((_("OK"), self.ui_group_do_add, None, GRAB_DEFAULT), (_("Cancel"), None, None))).show()
	def ui_group_do_add(self, name):
		profile = Profile(name)
		profile.show()
		self.gui.profiles.add(profile)
	def ui_group_remove(self, *args):
		profile = self.gui.profiles.current()
		if profile:
			GuiPopupQuestion(PI_NAME + " - " + _("Remove group"),
							 _("Remove the current group and all its connections?"), (None, None),
							 ((_("Yes"), self.ui_group_do_remove, (self.gui.profiles, profile)), (_("No"), None, None, GRAB_DEFAULT))).show()
	def ui_group_do_remove(self, profiles, profile):
		profiles.remove(profile)
	def ui_group_rename(self, *args):
		profile = self.gui.profiles.current()
		if profile:
			GuiPopupInput(PI_NAME + " - " + _("Rename group"),
						  _("Please enter the new name for the group:"), "", (None, None),
						  ((_("OK"), self.ui_group_do_rename, (profile,), GRAB_DEFAULT), (_("Cancel"), None, None))).show()
	def ui_group_do_rename(self, name, profile):
		profile.set_title(name)
	def ui_group_sync(self, *args):
		profile = self.gui.profiles.current()
		if profile:
			profile.sync()

# Callbacks: /Connection
	def ui_add_group_with_connection_add(self, name):
		profile = Profile(name)
		profile.show()
		self.gui.profiles.add(profile)
		self.ui_conn_add()
	def ui_conn_add(self, *args):
		profile = self.gui.profiles.current()
		if profile:
			item = Item()
			item.description.show()
			item.show()
			profile.add(item)
		else:
			GuiPopupInput(PI_NAME + " - " + _("New group"),
						  _("Please enter a name for the new group:"), "", (None, None),
						  ((_("OK"), self.ui_add_group_with_connection_add, None, GRAB_DEFAULT), (_("Cancel"), None, None))).show()
	def ui_conn_remove(self, *args):
		profile = self.gui.profiles.current()
		if profile:
			connection = profile.current()
			if connection:
				GuiPopupQuestion(PI_NAME + " - " + _("Remove connection"),
								 _("Remove the current connection?"), (None, None),
								 ((_("Yes"), self.ui_conn_do_remove, (profile, connection)), (_("No"), None, None, GRAB_DEFAULT))).show()
	def ui_conn_do_remove(self, profile, connection):
		profile.remove(connection)
	def ui_conn_edit(self, *args):
		profile = self.gui.profiles.current()
		if profile:
			connection = profile.current()
			if connection:
				connection.show()
	def ui_conn_sync(self, *args):
		profile = self.gui.profiles.current()
		if profile:
			connection = profile.current()
			if connection:
				connection.sync()

# Callbacks: /Help
	def ui_help_about(self, *args):
		about_box = GuiPopupQuestion(PI_NAME + " - " + _("About"), PI_ABOUT, (None, None), ((_("OK"), None, None, GRAB_DEFAULT),))
		about_box.question.set_line_wrap(FALSE)
		about_box.show()
	def ui_help_help(self, *args):
		show_help()
	def browse_web(self, url):
		if os.environ.has_key("BROWSER"):
			command = ("/bin/sh", ("-c", os.environ["BROWSER"] + " " + url,))
		else:
			command = (None, ())
		apply(spawn, command)
	def ui_help_expert(self, *args):
		self.browse_web(URL_MANDRAKE_EXPERT)
	def ui_help_bugreport(self, *args):
		GuiPopupQuestion(PI_NAME + " - " + _("Bug report"),
						 _("If you wish to report a bug, please connect to\n%s\nand fill in a bug report") % URL_MANDRAKE_QA,
						 (None, None), ((_("OK"), None, None, GRAB_DEFAULT),)).show()

class GuiToolbarTool(GtkToolbar):
	def __init__(self, gui):
		GuiToolbarTool.__bases__[0].__init__(self, ORIENTATION_HORIZONTAL, TOOLBAR_BOTH)
		self.set_button_relief(RELIEF_NONE)
		_gtk.gtk_object_set_data(self._o, "userclass", self)
		self.gui = gui
		icon = create_pixmap_from_xpm(self, self.get_style().bg[STATE_NORMAL], PI_ICONS_DIR + "/add_group.xpm")
		button = self.append_item(_("Add\nGroup"), _("Add a new group of connections"), "", GtkPixmap(icon[0], icon[1]), self.ui_add_group)
		sensitive_list_group_if_inactive.append(button)
		icon = create_pixmap_from_xpm(self, self.get_style().bg[STATE_NORMAL], PI_ICONS_DIR + "/add_connection.xpm")
		button = self.append_item(_("Add\nConnection"), _("Add a new connection"), "", GtkPixmap(icon[0], icon[1]), self.ui_add_connection)
		sensitive_list_connection_if_inactive.append(button)
		icon = create_pixmap_from_xpm(self, self.get_style().bg[STATE_NORMAL], PI_ICONS_DIR + "/remove_group.xpm")
		button = self.append_item(_("Remove\nGroup"), _("Remove the current group of connections"), "", GtkPixmap(icon[0], icon[1]), self.ui_remove_group)
		sensitive_list_group_if_active.append(button)
		icon = create_pixmap_from_xpm(self, self.get_style().bg[STATE_NORMAL], PI_ICONS_DIR + "/remove_connection.xpm")
		button = self.append_item(_("Remove\nConnection"), _("Remove the current connection"), "", GtkPixmap(icon[0], icon[1]), self.ui_remove_connection)
		sensitive_list_connection_if_active.append(button)
		icon = create_pixmap_from_xpm(self, self.get_style().bg[STATE_NORMAL], PI_ICONS_DIR + "/edit_connection.xpm")
		button = self.append_item(_("Edit\nConnection"), _("Edit the current connection"), "", GtkPixmap(icon[0], icon[1]), self.ui_edit_connection)
		sensitive_list_connection_if_active.append(button)
		icon = create_pixmap_from_xpm(self, self.get_style().bg[STATE_NORMAL], PI_ICONS_DIR + "/sync_all.xpm")
		button = self.append_item(_("Synchronize\nAll"), _("Synchronize all connections (in all groups)"), "", GtkPixmap(icon[0], icon[1]), self.ui_sync_all)
		sensitive_list_sync_all.append(button)
		icon = create_pixmap_from_xpm(self, self.get_style().bg[STATE_NORMAL], PI_ICONS_DIR + "/sync_group.xpm")
		button = self.append_item(_("Sync\nGroup"), _("Synchronize all connections in the current group"), "", GtkPixmap(icon[0], icon[1]), self.ui_sync_group)
		sensitive_list_sync_group.append(button)
		sensitive_list_group_if_active.append(button)
		icon = create_pixmap_from_xpm(self, self.get_style().bg[STATE_NORMAL], PI_ICONS_DIR + "/sync_connection.xpm")
		button = self.append_item(_("Sync\nConnection"), _("Synchronize the current connection"), "", GtkPixmap(icon[0], icon[1]), self.ui_sync_connection)
		sensitive_list_sync_connection.append(button)
		sensitive_list_connection_if_active.append(button)
		
#Callbacks
	def ui_add_group(self, *args):
		GuiPopupInput(PI_NAME + " - " + _("New group"),
					  _("Please enter a name for the new group:"), "", (None, None),
					  ((_("OK"), self.ui_add_group_add, None, GRAB_DEFAULT), (_("Cancel"), None, None))).show()
	def ui_add_group_add(self, name):
		profile = Profile(name)
		profile.show()
		self.gui.profiles.add(profile)
	def ui_add_group_with_connection_add(self, name):
		profile = Profile(name)
		profile.show()
		self.gui.profiles.add(profile)
		self.ui_add_connection()
	def ui_add_connection(self, *args):
		profile = self.gui.profiles.current()
		if profile:
			item = Item()
			item.description.show()
			item.show()
			profile.add(item)
		else:
			GuiPopupInput(PI_NAME + " - " + _("New group"),
						  _("Please enter a name for the new group:"), "", (None, None),
						  ((_("OK"), self.ui_add_group_with_connection_add, None, GRAB_DEFAULT), (_("Cancel"), None, None))).show()
	def ui_remove_group(self, *args):
		profile = self.gui.profiles.current()
		if profile:
			GuiPopupQuestion(PI_NAME + " - " + _("Remove group"),
							 _("Remove the current group and all its connections?"), (None, None),
							 ((_("Yes"), self.ui_remove_group_remove, (self.gui.profiles, profile)), (_("No"), None, None, GRAB_DEFAULT))).show()
	def ui_remove_group_remove(self, profiles, profile):
		profiles.remove(profile)
	def ui_remove_connection(self, *args):
		profile = self.gui.profiles.current()
		if profile:
			connection = profile.current()
			if connection:
				GuiPopupQuestion(PI_NAME + " - " + _("Remove connection"),
								 _("Remove the current connection?"), (None, None),
								 ((_("Yes"), self.ui_remove_connection_remove, (profile, connection)), (_("No"), None, None, GRAB_DEFAULT))).show()
	def ui_remove_connection_remove(self, profile, connection):
		profile.remove(connection)
	def ui_sync_all(self, *args):
		self.gui.profiles.sync()
	def ui_sync_group(self, *args):
		profile = self.gui.profiles.current()
		if profile:
			profile.sync()
	def ui_sync_connection(self, *args):
		profile = self.gui.profiles.current()
		if profile:
			connection = profile.current()
			if connection:
				connection.sync()
	def ui_edit_connection(self, *args):
		profile = self.gui.profiles.current()
		if profile:
			connection = profile.current()
			if connection:
				connection.show()

class GuiToolbar(GtkHandleBox):
	def __init__(self, gui):
		GuiToolbar.__bases__[0].__init__(self)
		_gtk.gtk_object_set_data(self._o, "userclass", self)
		self.toolbar = GuiToolbarTool(gui)
		self.add(self.toolbar)  
	def show(self):
		self.toolbar.show()
		GuiToolbar.__bases__[0].show(self)

class Gui(GtkWindow):
	def __init__(self, profiles):
		Gui.__bases__[0].__init__(self)
		_gtk.gtk_object_set_data(self._o, "userclass", self)
		self.set_default_size(512, 384)
		self.set_title(PI_NAME)
		self.connect("delete_event", self.ui_close)
		self.box = GtkVBox()
		if not profiles:
			profiles = Profiles()
		self.menubar = GuiMenubar(self)
		self.box.pack_start(self.menubar, FALSE, FALSE, 0)
		self.toolbar = GuiToolbar(self)
		self.box.pack_start(self.toolbar, FALSE, FALSE, 0)
		self.profiles = profiles
		self.box.pack_start(self.profiles, TRUE, TRUE, 0)
		self.add(self.box)
	def show(self):
		self.menubar.show()
		self.toolbar.show()
		self.profiles.show()
		self.box.show()
		Gui.__bases__[0].show(self)
	def __repr__(self):
		return "draksync[\"profiles\"] = " + repr(self.profiles)
#Callbacks##Ui
	def ui_close(self, *args):
		save(self)
		self.hide()
		mainquit()

def add_save_ftp_profile(group, ftpinfo):
	if DEBUG:
		print ">>> Add new ftp profile to group '%s'" % group
		print ftpinfo

	profile = gui.profiles.find(group)
	if not profile:
		profile = Profile(group)
		profile.show()
		gui.profiles.add(profile)

	item = Item(ftpinfo.local_dir,
				ftpinfo.username,
				ftpinfo.password,
				ftpinfo.hostname,
				ftpinfo.remote_dir,
				ST_LOCAL_IS_NEWER,
				CT_FTP,
				TRUE)
	
	profile.add(item)
	item.description.show()

draksync = {"profiles":None}
load()
gui = Gui(draksync["profiles"])
update_sensitive_lists(gui.profiles)
gui.show()
mainloop()
