# ------------------------------------------------------------------------------
# Error Description

class BasicError:
	def __init__(self, message = ""):
		self.message = message
	def __str__(self):
		return self.message

class Error(BasicError):

	def __init__(self, location, message):
		self.location = location
		self.message = message

	def __str__(self):
		return self.location + ": " + self.message

# ------------------------------------------------------------------------------
# Common errors

class UnknownHost(BasicError): pass
class LoginFailed(BasicError): pass
class PermissionDenied(BasicError): pass
class MutualSyncDifferentPermissions(BasicError): pass
class MutualSyncDifferentSizes(BasicError): pass
class ConnectionClosed(BasicError): pass

# Unknown FTP error, store FTP reply
class FTPError(BasicError):
	def __init__(self, reply):
		self.reply = reply
	def __str__(self):
		return self.reply

class DirectoryNotFound(BasicError):
	def __init__(self, dirname):
		self.dirname = dirname
	def __str__(self):
		return self.dirname

# ------------------------------------------------------------------------------
# Errors specific to the FTP protocol

# ------------------------------------------------------------------------------
# Internal Error Description

class InternalError(Error):

	def __init__(self, location, message):
		self.location = location
		self.message = message

# ------------------------------------------------------------------------------
# Local Variables:
# tab-width: 4
# End:
