DEBUG = 0

import os
from Constants import TRUE, FALSE																# Boolean Values
from Constants import NET_MONITOR_APP, NET_MONITOR_APP_AUTH										# Paths to Net Monitor

# ------------------------------------------------------------------------------
# Network abstraction

class Network:

	def __spawn(self, command, args):
		if command:
			pid = os.fork()
			if pid == 0:
				os.execvp(command, (command,) + args)
			else:
				return pid

	def isActive(self):
		if DEBUG:
			print "Network::isActive()"
		
		fd = os.popen(NET_MONITOR_APP + " --status --quiet", "r")
		status = fd.read()
		# net_monitor --status outputs "1" is network is up, "0" otherwise
		return status

	def isSetup(self):
		if DEBUG:
			print "Network::isSetup()"
		# FIXME: always assume network is up for now
		return TRUE

	def connect(self):
		if DEBUG:
			print "Network::connect()"
		pid = self.__spawn(NET_MONITOR_APP_AUTH, ("--connect", "--quiet"))
		(pid, status) = os.waitpid(pid, 0)
		
	def disconnect(self):
		if DEBUG:
			print "Network::disconnect()"
		pid = self.__spawn(NET_MONITOR_APP_AUTH, ("--disconnect", "--quiet"))
		(pid, status) = os.waitpid(pid, 0)

